// O(X^4 * N) - 30 puncte
// Autor: Tudose Vlad Andrei

#include <cstdio>
#include <algorithm>
#define INF 1000000000000000000ll
#define NMAX 2000005
#define ll long long
using namespace std;

ll X[NMAX], Y[NMAX], Z[NMAX];

int main() {
	freopen("cuburi.in", "r", stdin);
	freopen("cuburi4.out", "w", stdout);
	
	int n;
	ll ax, bx, cx, ay, by, cy, az, bz, cz;
	scanf("%d%lld%lld%lld%lld%lld%lld%lld%lld%lld", &n, &ax, &bx, &cx, &ay, &by, &cy, &az, &bz, &cz);
	
	X[1] = Y[1] = Z[1] = 1;
	for(int i = 2; i <= n; ++i) {
		X[i] = (X[i - 1] * ax + bx * i) % cx;
		Y[i] = (Y[i - 1] * ay + by * i) % cy;
		Z[i] = (Z[i - 1] * az + bz * i) % cz;
	}
	
	ll ans = INF;
	for(ll x = 0; x < cx; ++x)
		for(ll y = 0; y < cy; ++y)
			for(ll z = 0; z < cz; ++z)
				for(ll l = 0; l < cx || l < cy || l < cz; ++l) {
					ll xmin = INF, xmax = -INF, ymin = INF, ymax = -INF, zmin = INF, zmax = -INF;
					for(int i = 1; i <= n; ++i)
						if(X[i] < x || Y[i] < y || Z[i] < z || X[i] > x + l || Y[i] > y + l || Z[i] > z + l) {
							xmin = min(xmin, X[i]);
							xmax = max(xmax, X[i]);
							ymin = min(ymin, Y[i]);
							ymax = max(ymax, Y[i]);
							zmin = min(zmin, Z[i]);
							zmax = max(zmax, Z[i]);
						}
					ll l2 = max(xmax - xmin, max(ymax - ymin, zmax - zmin));
					ans = min(ans, max(l, l2));
				}
	
	printf("%lld\n", ans);
	return 0;
}