// O(N * log(X)) - 70 puncte
// Autor: Tudose Vlad Andrei

#include <cstdio>
#include <algorithm>
#define NMAX 2000005
#define ll long long
using namespace std;

int n;
ll X[NMAX], Y[NMAX], Z[NMAX], xmin, xmax, ymin, ymax, zmin, zmax;

ll dist(ll x1, ll y1, ll z1, ll x2, ll y2, ll z2) {
	ll dx = abs(x1 - x2);
	ll dy = abs(y1 - y2);
	ll dz = abs(z1 - z2);
	return max(dx, max(dy, dz));
}

int check(ll x, ll y, ll z, ll l) {
	ll xmin = 1, xmax = 1, ymin = 1, ymax = 1, zmin = 1, zmax = 1;
	
	for(int i = 1; i <= n; ++i)
		if(dist(X[i], Y[i], Z[i], x, y, z) > l) {
			xmin = min(xmin, X[i]);
			xmax = max(xmax, X[i]);
			ymin = min(ymin, Y[i]);
			ymax = max(ymax, Y[i]);
			zmin = min(zmin, Z[i]);
			zmax = max(zmax, Z[i]);
		}
	return (xmax - xmin) <= l && (ymax - ymin) <= l && (zmax - zmin) <= l;
}

int ok(ll l) {
	if(check(xmin, ymin, zmin, l)) return 1;
	if(check(xmin, ymin, zmax, l)) return 1;
	if(check(xmin, ymax, zmin, l)) return 1;
	if(check(xmin, ymax, zmax, l)) return 1;
	if(check(xmax, ymin, zmin, l)) return 1;
	if(check(xmax, ymin, zmax, l)) return 1;
	if(check(xmax, ymax, zmin, l)) return 1;
	return check(xmax, ymax, zmax, l);
}

int main() {
	freopen("cuburi.in", "r", stdin);
	freopen("cuburi.out", "w", stdout);
	
	ll ax, bx, cx, ay, by, cy, az, bz, cz;
	scanf("%d%lld%lld%lld%lld%lld%lld%lld%lld%lld", &n, &ax, &bx, &cx, &ay, &by, &cy, &az, &bz, &cz);
	
	X[1] = Y[1] = Z[1] = xmin = xmax = ymin = ymax = zmin = zmax = 1;
	for(int i = 2; i <= n; ++i) {
		X[i] = (X[i - 1] * ax + bx * i) % cx;
		Y[i] = (Y[i - 1] * ay + by * i) % cy;
		Z[i] = (Z[i - 1] * az + bz * i) % cz;
		xmin = min(xmin, X[i]);
		xmax = max(xmax, X[i]);
		ymin = min(ymin, Y[i]);
		ymax = max(ymax, Y[i]);
		zmin = min(zmin, Z[i]);
		zmax = max(zmax, Z[i]);
	}
	
	ll l = 0, r = 1000000000000000000ll;
	
	while(l < r) {
		ll md = (l + r) / 2;
		if(ok(md))
			r = md;
		else
			l = md + 1;
	}
	
	printf("%lld\n", l);
	return 0;
}
